﻿// version 1.5= autoupdate radio stations

var currentVers = 1.5;
var lastUpdate = new Date();
lastUpdate.setFullYear(1992);
var radioVers = 1;

var widgetNumber = "10111";		
var daysAfter = 10;
var wherePopUp = "wrapper_div";

var DEFAULT_RADIO = 0;
var DEFAULT_AP = "0";

var DEFAULT_RADIO_IDS = "107,28,71,41,18,6,72,16,39,13,15,65,27,10,17,22,31,108,25,21,19,33,20,23,64,12,7,11";
var DEFAULT_RADIO_NAMES = "charts,film/tv,hits,covers,dancefloor,electro,trip hop,pop,pop folk,indie pop,jazz vocal,blues,classic rock,rock,hard,metal,punk,reggae ska dub,disco,funk,soul,r&b,rap,rap français,urban style,chanson française,nouvelle scène,variété française";

var radioIds = DEFAULT_RADIO_IDS;
var radioNames = DEFAULT_RADIO_NAMES;
var numRadios = 0;

var radio = DEFAULT_RADIO;
var ap = DEFAULT_AP;


var visible_prefs = false;
var force_autoplay = false;

var radioStations = new Array();

function checkUpdates() {
	var now = new Date();
	var nowTime = now.getTime();	
	
	if (widget.preferenceForKey('lastUpdate')) {
		lastUpdate = new Date( widget.preferenceForKey('lastUpdate'));
	} else { //FIRST TIME ONLY
		widget.setPreferenceForKey( now.toString() , 'lastUpdate' ); 
	};
	var lastTime = lastUpdate.getTime();	
	if (( nowTime - lastTime) > (daysAfter *  24 * 60 * 60 * 1000)) {
		var xhr = new XMLHttpRequest ();
		xhr.onreadystatechange = function () {
			if ( this.readyState == 4 )
			{
				switch ( this.status )
				{
					case 200:
						widget.setPreferenceForKey( now.toString() , 'lastUpdate' ); 
						checkHTML(xhr.responseText);
					break;
					default:
					// failed update check, quit
				};
			};
		};
		try{
			xhr.open( 'GET', 'http://widgets.opera.com/widget/'+widgetNumber+'/', true );
			xhr.send(null);
		} catch(e) {	// no network connection 
		}
	};
};

function checkHTML(x) {
	var info = "";
	var lapo = x.indexOf("§§§");
	var parth = x.substr( 0 , lapo);
	var vfipo = parth.indexOf("ççç");
	var vlapo = parth.indexOf("òòò");
	var radversi = parth.substr( (3+vfipo), (vlapo-vfipo-3));
	var currv = parseFloat(radversi);
	
	if (currv > radioVers) { 
	radioVers = currv;
	
	var nfipo = parth.indexOf("^^^");
	var nlapo = parth.indexOf("£££");
	radioNames = parth.substr( (3+nfipo), (nlapo-nfipo-3));
	radioNames = radioNames.replace(/&amp;/g, "&");
	
	var ifipo = parth.indexOf("°°°");
	radioIds = parth.substr((3+ifipo));
	
	widget.setPreferenceForKey( radioIds , 'rids' ); 
	widget.setPreferenceForKey( radioNames , 'rnames' ); 
	widget.setPreferenceForKey( radioVers , 'rvers' ); 
	showDiv("radio_div");
	}
	
	var start = parth.indexOf("/widget/doap/");
	if (start != -1) {
		var tempvers = parth.substr( (13 + start + widgetNumber.length + 1),(widgetNumber.length + 10)); //10 chars
		var strend = tempvers.indexOf("/");
		var vers = tempvers.substr(0, strend);
		var lin = "http://widgets.opera.com/widget/" + widgetNumber + "/";
		var flovers = parseFloat(vers);
		if ( flovers > currentVers) {
			var d = document.getElementById(wherePopUp); 
			var infbox = document.createElement("div");
			infbox.id = "infobox";
			var ip1 = document.createElement("p");
			var ipt1 = document.createTextNode("Please upgrade to ");
			var ipa1 = document.createElement("a");
			ipa1.href = lin;
			ipa1.target = "_blank";
			var ipa1t = document.createTextNode("version " + vers);
			ipa1.appendChild(ipa1t);
			ip1.appendChild(ipt1);
			ip1.appendChild(ipa1);
			infbox.appendChild(ip1);
			
			var sp = document.createElement("span");
			var ipa2 = document.createElement("a");
			ipa2.href = "#";
			ipa2.onclick = function() { closeinfo(); return false; } ;
			var ipa2t = document.createTextNode("CLOSE");
			ipa2.appendChild(ipa2t);
			sp.appendChild(ipa2);
			infbox.appendChild(sp);

			d.appendChild(infbox);
		};
	};
};

function closeinfo() {
	var i = document.getElementById("infobox");
	removeContents(i);
	i.parentNode.removeChild(i);
};






function init()
{

	if (widget.preferenceForKey('radio')) radio = widget.preferenceForKey('radio');
	if (widget.preferenceForKey('ap')) ap = widget.preferenceForKey('ap');
	
	if (widget.preferenceForKey('rids')) radioIds = widget.preferenceForKey('rids');
	if (widget.preferenceForKey('rnames')) radioNames = widget.preferenceForKey('rnames');
	if (widget.preferenceForKey('rvers')) radioVers = widget.preferenceForKey('rvers');
	
	showDiv("radio_div");
	checkUpdates();
}

function buildOptions(sel) {

  
  var raids = radioIds.split(",");
  var ranames = radioNames.split(",");
  radioStations[0] = raids;
  radioStations[1] = ranames;
  numRadios = raids.length;
  if (radio> (numRadios-1)) radio = 0;
 
 
	for (var i=0; i<numRadios; i++) {
		var o = document.createElement("option");
		o.value = radioStations[0][i];
		var ot = document.createTextNode(radioStations[1][i]);
		o.appendChild(ot);
		sel.appendChild(o);
	}
}

function removeContents(x) {
	while(x.hasChildNodes() ) { 
		removeContents(x.firstChild);
		x.removeChild(x.firstChild ); 
	}	
}

function showDiv(whichdiv) {

	// destroy
	var cd = document.getElementById("container_div");
	removeContents(cd);
	
	//build
	switch(whichdiv) {
		case "radio_div": 
			var rd = document.createElement("div");
			rd.id = "radio_div";
			cd.appendChild(rd);
			
			var s = document.createElement("select");
			s.id = "sel_radio";
			s.onchange = function() { changeStation(this); };
			buildOptions(s);
			//s.options[radio].selected = "selected";
			s.selectedIndex = radio;
			rd.appendChild(s);
			
			var pd = document.createElement("div");
			pd.id = "radio_player_div";
			rd.appendChild(pd);
			
			startRadio();
		break;
		
		case "prefs_div": 

			var pdiv = document.createElement("div");
			pdiv.id = "prefs_div";
			cd.appendChild(pdiv);
			
			var li1d = document.createElement("div");
			var t1 = document.createTextNode("default radio:");
			li1d.appendChild(t1);
			var sp = document.createElement("select");
			sp.id = "sel_radio_prefs";
			buildOptions(sp);
			//sp.options[radio].selected = "selected";
			sp.selectedIndex = radio;
			li1d.appendChild(sp);
			pdiv.appendChild(li1d);

			var ul= document.createElement("ul");
			pdiv.appendChild(ul);
			
			var li2 = document.createElement("li");
			var t2 = document.createTextNode("autoplay?");
			li2.appendChild(t2);
			var cb = document.createElement("input");
			cb.type = "checkbox";
			cb.id = "ap_input";			
			//if (ap == "1") { cb.checked = "checked"; } else { cb.checked = ""; }  YOU CAN SET STRING VALUES, BUT YOU CAN'T READ THEM (THEY BECOME BOOLEANS)
			if (ap == "1") { cb.checked = true; } else { cb.checked = false; } 
			li2.appendChild(cb);
			ul.appendChild(li2);
			
		
			var b7 = document.createElement("button");
			b7.setAttribute("type", "button");
			b7.id = "butt_def";
			b7.onclick = function() { defaults(); };
			var b7t = document.createTextNode("Load default values");
			b7.appendChild(b7t);
			pdiv.appendChild(b7);	

			var infodiv = document.createElement("div");
			infodiv.id ="info_div";
			var d1 = document.createElement("p");
			var d1t = document.createTextNode("version " + currentVers.toString() + "r" + radioVers.toString() );
			d1.appendChild(d1t);
			infodiv.appendChild(d1);
			
			var d2 = document.createElement("p");			
			var d2t = document.createTextNode("Written by: ");
			d2.appendChild(d2t);
			var a1 = document.createElement("a");
			a1.href = "http://www.donatofurlani.it/ideas";
			a1.target = "top";
			var a1t = document.createTextNode("Donato Furlani");
			a1.appendChild(a1t);
			d2.appendChild(a1);
			infodiv.appendChild(d2);
			pdiv.appendChild(infodiv);
			
		break;
		
		
		
		default:
		//none
	}

}

function startRadio() {
	var x = document.getElementById("radio_player_div");
	var auto_play = ap;
	if (force_autoplay) { 
		auto_play = "1"; 
		force_autoplay = false; 
	}
	var radioId = radioStations[0][radio];
	var deezURL = "http://www.deezer.com/embed/player?rid=" + radioId + "&lang=en&ap=" + auto_play;
 

		var ob = document.createElement("object");
		ob.setAttribute("type", "application/x-shockwave-flash");
		ob.setAttribute("width", "180");
		ob.setAttribute("height", "220");
		ob.setAttribute("data", deezURL);

		var par1 = document.createElement("param");
		par1.setAttribute("name","movie"); 
		par1.setAttribute("value", deezURL);
		
		var par2 = document.createElement("param");
		par1.setAttribute("name","wmode"); 
		par1.setAttribute("value", "transparent");
		

		ob.appendChild(par1);
		ob.appendChild(par2);

		removeContents(x);		
		x.appendChild(ob);
}


function changeStation(sel) {
	radio = sel.selectedIndex;
	force_autoplay = true;
	startRadio(); 
}



function closew() {
	window.close();
}

function defaults() {
	var sel_radio_prefs = document.getElementById("sel_radio_prefs");
	var ap_check = document.getElementById("ap_input");
			
	sel_radio_prefs.options[DEFAULT_RADIO].selected = "selected";

	if (DEFAULT_AP == "1") 
	//{ ap_check.setAttribute("checked", true); } else { ap_check.setAttribute("checked", false); }  DOESN'T WORK
	{ ap_check.checked = true; } else { ap_check.checked = false; } 
	
}

function wprefs() {
	
	if (!visible_prefs) {
		visible_prefs = true;
		showDiv("prefs_div");	

	} else {
		var sel_radio_prefs = document.getElementById("sel_radio_prefs");
		var ap_check = document.getElementById("ap_input");
		
		radio = sel_radio_prefs.selectedIndex;
		// if (ap_check.checked == "checked") { ap = "1"; } else { ap = "0"; }  DOESN'T WORK
		if (ap_check.checked == true) { ap = "1"; } else { ap = "0"; }
		
		store_preferences();
		visible_prefs = false;		
		showDiv("radio_div");
	}
}


function store_preferences() {
	widget.setPreferenceForKey( radio , 'radio' );
	widget.setPreferenceForKey( ap , 'ap' );

}

window.onload = init;
